//+----------------------------------------------------------------------------------------+
//|                                                                                        
//| original dlls for digital filters
//| made by Sergey Iljukhin, Novosibirsk
//| 
//| notice :
//| in order to work properly following 4 dlls must be present in windows\system32
//|      bdsp.dll, lapack.dll, mkl_support.dll and df.dll
//|
//|
//|  parameters description :
//|  
//|  Ftype -  : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 
//|          2 -  (RBCI/KGBP), 3 -  (KGBS)
//|  P1 -      P1, 
//|  D1 -        D1, 
//|  A1 -        1, 
//|  P2 -      P2, 
//|  D2 -        D2, 
//|  A2 -        2, 
//|  Ripple -    , 
//|  Delay - , 
//|
//|        P2,D2,A2 
//|   :
//|  : P1>D1
//|  : P1<D1
//|    : D2>P2>P1>D1
//|
//+----------------------------------------------------------------------------------------+

#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

#import "df.dll"
   int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2, double Ripple, int Delay, double& arr[]); 
#import

//
//
//
//
//

extern int    Price         = PRICE_CLOSE;
extern int    FilterSubType =  0;
extern int    FilterType    =  0;  // : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 2 -  (RBCI/KGBP), 3 -  (KGBS)
extern int    P1            = 28;  //  P1, 
extern int    D1            = 19;  //    D1, 
extern int    A1            = 40;  //    1, 
extern int    P2            =  0;  //  P2, 
extern int    D2            =  0;  //    D2, 
extern int    A2            =  0;  //    2, 
extern int    Delay         =  0;  //, 
extern double Ripple        = 0.08;//   ,  

//
//
//
//
//

double values[];
double prices[];
double Filter[1500];
int    FilterSize;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------  
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0, values);
   SetIndexBuffer(1, prices);

   //
   //
   //
   //
   //

   switch(FilterSubType)
   {
      case 1: P1=10; D1=08; Ripple=0.864; break;
      case 2: P1=79; D1=35; Ripple=0.039; break; //Satl
   }      
   
   //
   //
   //
   //
   //
   
   FilterSize=DigitalFilter(FilterType, P1, D1, A1, P2, D2, A2, Ripple, Delay, Filter);  
      if (FilterSize>0) ArrayResize(Filter,FilterSize+1);
      SetIndexDrawBegin(0, FilterSize+30);
   IndicatorDigits(Digits);
   return(0); 
} 


//+------------------------------------------------------------------+  
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//
//
//
//
 
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //
         //
         //
         
         bool canWork=true;
            if (FilterSize>=Bars) canWork = false;  
            if (FilterSize<1    ) canWork = false;
            if (canWork)
               switch (FilterType)
               {
                  case 0:   canWork = (P1>D1); break;
                  case 1:   canWork = (P1<D1); break;
               }
            if (!canWork) { Comment("parameters conditions not fulfilled"); return(0); }
            Comment("");

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      values[i] = 0;
         for(int k=0; k<=FilterSize; k++)  values[i] += Filter[k]*prices[i+k];
   }
   return(0); 
}